import 'package:unit_rc/UnitRCLog.dart';

mixin UnitRCApplicationMixin {
  bool isApplicationValid();
  dynamic getCurrApplication();
}

class UnitRCApplication {
  UnitRCApplication._();

  static UnitRCApplicationMixin? _mixin;
  static void registerUnitRCApplicationMixin(
      UnitRCApplicationMixin mixin) {
    _mixin = mixin;
  }

  static bool isApplicationValid() {
    return _mixin?.isApplicationValid() ?? false;
  }

  static dynamic getCurrApplication() {
    return _mixin?.getCurrApplication();
  }
}
