import 'dart:async';
import 'dart:ffi';
import 'dart:isolate';

import 'FFIType.dart';
import 'UnitRCDartRuntime.dart';

final executeMessageQueue =
    unitRCLib.lookupFunction<Void Function(Int64), void Function(int)>(
        "UnitRC_ExecuteMessageQueue");

void requestExecuteCallback(dynamic message) {
// 特殊信息，仅用于判断 vm 是否还存活
  if (message == -100) {
    return;
  }

// block
  final int queueAddress = message;
  executeMessageQueue(queueAddress);
}

class UnitRCDartNotify {

  static bool _isRegistered = false;
  static void registerNativeMethods() {
    if (_isRegistered) {
      return;
    }
    _isRegistered = true;
  }
}
