import 'package:flutter/foundation.dart';
import 'package:unit_rc/UnitRCLog.dart';

class UnitRCError {
  UnitRCError._();

  static void report({required Object e, StackTrace? stack, String? context}) {
    UnitRCLog.error("error: ${e}, stack: ${stack}, context: ${context}");
    FlutterError.reportError(FlutterErrorDetails(
      exception: e,
      stack: stack,
      library: "unit_rc",
      context: ErrorDescription(context ?? ""),
    ));
  }

  static void reportWithMsg(String errorMsg) {
    try {
      throw Exception(errorMsg);
    } catch (e, stack) {
      report(e: e, stack: stack);
      rethrow;
    }
  }
}
