import 'dart:ffi';

import 'package:unit_rc/UnitRC.dart';

enum UnitRCLogLevel {
  verbose,
  debug,
  info,
  warn,
  error,
  fatal,
  none,
}

class UnitRCLog {

  static void info(String msg) {
    _log(UnitRCLogLevel.info, msg);
  }

  static void error(String msg) {
    _log(UnitRCLogLevel.error, msg);
  }

  static void _log(UnitRCLogLevel level, String msg) {
    final level_ffi = level.index;
    final msg_ffi = Uint8ListFFI.createWithString(msg);
    _native_log(level_ffi, msg_ffi);
    Uint8ListFFI.free(msg_ffi);
  }

  static late final _native_log = unitRCLib.lookupFunction<
      Void Function(Int32, Pointer<Uint8ListFFI>),
      void Function(int, Pointer<Uint8ListFFI>)>("UnitRC_log");

  UnitRCLog._();
}
