import 'dart:ffi';

import 'package:unit_rc/DartBase.dart';
import 'package:unit_rc/UnitRC.dart';
import 'package:unit_rc/ur/InternalClassList.dart';

class InternalClassListDart extends InternalClassList {
  final List<dynamic> data = [];

  InternalClassListDart.fromList(List<dynamic> list) {
    data.addAll(list);
  }

  @override
  int count() {
    return data.length;
  }

  dynamic get(int index) {
    return data[index];
  }

  static Object? getObject(Object? object, int index) {
    var object_dart = object as InternalClassListDart?;
    var object_zone = (object as DartBaseClass?)?.zone;
    if (object_dart == null || object_zone == null) {
      return null;
    }

    Object? result = object_zone.run(() {
      try {
        return object_dart.get(index);
      } catch (e, stack) {
        print("error: $e, stack: $stack");
        return null;
      }
    });
    return result;
  }
  static final getObjectFP = Pointer.fromFunction<
      Handle Function(Handle, Int64)
  >(getObject);
  static final registerGetObjectFP = unitRCLib.lookupFunction<
      Void Function(Pointer<NativeFunction<Handle Function(Handle, Int64)>>),
      void Function(Pointer<NativeFunction<Handle Function(Handle, Int64)>>)
  >("UnitRC_Register_InternalClassListDart_get");

  static void registerNativeMethods() {
    registerGetObjectFP(getObjectFP);
  }
}
