import 'dart:async';
import 'dart:ffi';
import 'dart:typed_data';
export 'package:unit_rc/UnitRC.dart';
import './UnitRCInit.dart';
import 'FuncDeclareDart.dart';
import 'InternalClassList.dart';
import 'InternalClassListDartBridge.dart';
import 'InternalClassListCppBridge.dart';

class InternalClassListCpp extends InternalClassList with DartBaseProxyClass, InternalClassListCppMixin {
}

mixin InternalClassListCppMixin on DartBaseProxyClass {
    int count() {
        var result = _native_count(toCpp(), );
        return result;
    }
    static late final _native_count = lib.lookupFunction<
        Uint64 Function(Pointer<Void>, ),
        int Function(Pointer<Void>, )
    >("UnitRC_InternalClassListCpp_count");

    static late final lib = _lib;
    static DynamicLibrary get _lib {
        final lib = UnitRCInit.lib;
        InternalClassListDartBridge.registerNativeMethods();
        InternalClassListCppBridge.registerNativeMethods();
        return lib;
    }
}