import 'dart:ffi';
import 'package:unit_rc/UnitRC.dart';
import 'UnitRCInit.dart';
import 'InternalClassListCpp.dart';

class InternalClassListCppBridge {
    static Object createInternalClassListCpp() {
        return InternalClassListCpp();
    }

    static final createInternalClassListCppFP = Pointer.fromFunction<Handle Function()>(createInternalClassListCpp);
    static final registerCreateInternalClassListCppFP = UnitRCInit.lib.lookupFunction<
        Void Function(Pointer<NativeFunction<Handle Function()>>),
        void Function(Pointer<NativeFunction<Handle Function()>>)
    >("UnitRC_Register_InternalClassListCpp_createHandle");

    static bool _registered = false;
    static void registerNativeMethods() {
        if (_registered) return;
        _registered = true;
        registerCreateInternalClassListCppFP(createInternalClassListCppFP);
    }
}