import 'dart:ffi';
import 'dart:typed_data';
import 'package:unit_rc/UnitRC.dart';
import './UnitRCInit.dart';
import 'FuncDeclare.dart';
import 'FuncDeclareDart.dart';
import 'InternalClassList.dart';

class InternalClassListDartBridge {

    static int count(Object? object) {
        var object_InternalClassList = object as InternalClassList?;
        var object_zone = object_InternalClassList?.zone;
        if (object_InternalClassList == null || object_zone == null) {
            return 0;
        }
        int result = object_zone.run(() {
            try {
                return object_InternalClassList.count();
            } catch (e, stack) {
                UnitRCError.report(e: e, stack: stack, context:"count");
                return 0;
            }
        });
        return result;
    }
    static final countFP = Pointer.fromFunction<
        Uint64 Function(Handle, )
    >(count, 0);
    static final registerCountFP = UnitRCInit.lib.lookupFunction<
        Void Function(Pointer<NativeFunction<Uint64 Function(Handle)>>),
        void Function(Pointer<NativeFunction<Uint64 Function(Handle)>>)
    >("UnitRC_Register_InternalClassListDart_count");

    static bool _registered = false;
    static void registerNativeMethods() {
        if (_registered) return;
        _registered = true;
        registerCountFP(countFP);
    }
}