import 'dart:async';
import 'dart:ffi';
import 'dart:typed_data';
export 'package:unit_rc/UnitRC.dart';
import './UnitRCInit.dart';
import 'FuncDeclareDart.dart';
import 'ThreadUtils.dart';
import 'ThreadUtilsCppBridge.dart';

class ThreadUtilsCpp extends ThreadUtils with DartBaseProxyClass, ThreadUtilsCppMixin {
    static void runOnMainThread(void Function()? runnable) {
        var runnable_ffi = FuncDeclareDart.from_Void_Empty(runnable);
        _native_runOnMainThread(runnable_ffi);
    }
    static late final _native_runOnMainThread = ThreadUtilsCppMixin.lib.lookupFunction<
        Void Function(Handle),
        void Function(Object?)
    >("UnitRC_ThreadUtilsCpp_runOnMainThread");

}

mixin ThreadUtilsCppMixin on DartBaseProxyClass {
    static late final lib = _lib;
    static DynamicLibrary get _lib {
        final lib = UnitRCInit.lib;
        ThreadUtilsCppBridge.registerNativeMethods();
        return lib;
    }
}