import 'dart:ffi';
import 'package:unit_rc/UnitRC.dart';
import 'UnitRCInit.dart';
import 'ThreadUtilsCpp.dart';
import 'FuncDeclareDartBridge.dart';
import 'FuncDeclareCppBridge.dart';

class ThreadUtilsCppBridge {
    static Object createThreadUtilsCpp() {
        return ThreadUtilsCpp();
    }

    static final createThreadUtilsCppFP = Pointer.fromFunction<Handle Function()>(createThreadUtilsCpp);
    static final registerCreateThreadUtilsCppFP = UnitRCInit.lib.lookupFunction<
        Void Function(Pointer<NativeFunction<Handle Function()>>),
        void Function(Pointer<NativeFunction<Handle Function()>>)
    >("UnitRC_Register_ThreadUtilsCpp_createHandle");

    static bool _registered = false;
    static void registerNativeMethods() {
        if (_registered) return;
        _registered = true;
        registerCreateThreadUtilsCppFP(createThreadUtilsCppFP);
        FuncDeclareDartBridge.registerNativeMethods();
        FuncDeclareCppBridge.registerNativeMethods();
    }
}