import 'dart:ffi';
import 'dart:io';
import 'package:unit_rc/UnitRC.dart';
import './FuncDeclare.dart';

class UnitRCInit {
    UnitRCInit._();

    static late final lib = _lib;
    static DynamicLibrary get _lib {
        registerNativeMethods();
        return Platform.isAndroid
            ? DynamicLibrary.open('libunit_rc.so')
            : DynamicLibrary.process();
    }

    static void registerNativeMethods() {
        UnitRCDartRuntime.registerNativeMethods();
        UnitRCDartNotify.registerNativeMethods();
        FFIType.registerNativeMethods();
    }
}

extension DynamicLibraryUnitRCEx on DynamicLibrary {
    bool get isRegistered {
        return UnitRCDartRuntime.isRegistered;
    }
}